//
//  Compressor.cpp
//  audio
//
//  Created by cmtuser on 09/03/15.
//
//

#include <cmath>
#include "Compressor.h"

Compressor::Compressor(float a, float r, float d) {
    attack = a;
    release = r;
    drive = d;
    sidechain = 1;
}
/*
float Compressor::Process(float input) {
    input = input * drive;
    float delta = fabs(input) - sidechain;
    if (delta > attack) delta = attack;
    if (delta < release) delta = release;
    sidechain += delta;
    
    float target_level = tanh(sidechain);
    float attenuation = target_level / sidechain;
    
    return input * attenuation;
}
*/

float Compressor::Process(float input) {
    input = input * drive;
    float level = fabs(input) + 0.00001;
    float target_level = tanh(level);
    float attenuation = target_level / level;
    
    float speed = attack;
    if (attenuation > sidechain) speed = release;
    
    sidechain = sidechain + speed * (attenuation - sidechain);
    return input * sidechain;
}











