//
//  Control.cpp
//  audio
//
//  Created by cmtuser on 16/03/15.
//
//

#include <AudioToolbox/AudioToolbox.h>
#include <CoreAudio/CoreAudio.h>
#include "cahelper.h"

#include "Control.h"

Control::Control(float updateFrequency, std::function<void(void)> updateProc) {
    update = updateProc;
    controlInterval = PlayerSampleRate / updateFrequency;
    controlCounter = controlInterval;
}

float Control::Process(float in) {
    controlCounter = controlCounter - 1;
    if (controlCounter < 1) {
        update();
        controlCounter = controlInterval;
    }
    return in;
}
